#include "Othello.h"

/* ---------------------------------------
	IZ̕`n֐
 --------------------------------------- */
HPEN hPen[PEN_SIZE];
HBRUSH hBrush[BRUSH_SIZE];

long LineSize;
long LineInside;
long CircleOffset;
long CircleSize;
long turn_flag;
long turn_count;

POINT mouse_pt;		//	}EXJ[\ XY
POINT board_pt;		//	board ̔z@X/Y

// int pen_id[] = { PEN_1, PEN_2, PEN_3 };

board_tag othello_board[LINE_COUNT][LINE_COUNT];
status_tag status_buff[PLAYER_COUNT];


/* ---------------------------------------
	IZ̏
 --------------------------------------- */
int Othello_init()
{
	hPen[0] = CreatePen(PS_SOLID,2,RGB(0,0x60,0));
	hPen[1] = CreatePen(PS_SOLID,1,RGB(0,0x00,0));
	hPen[2] = CreatePen(PS_SOLID,5,RGB(0xFF,0x80,0));

	hBrush[0] = CreateSolidBrush(RGB(0x00 ,0x00 , 0x00));	//	gp̃uV
	hBrush[1] = CreateSolidBrush(RGB(0x44 ,0x44 , 0x44));	//	IZ̍
	hBrush[2] = CreateSolidBrush(RGB(0xEE ,0xEE , 0xEE));	//	IZ̔

	LineSize	= LINE_WIDTH;		//	}Xڂ̕	l
	CircleSize	= CIRCLE_WIDTH;		//	~̒a	l

//	game_buff_init();		//	IZot@[̏
//	game_work_init();		//	Q[Zbg	
//	game_point_calc();		//	R}𐔂

return 0;
}

/* ---------------------------------------
	IZ̕`
 --------------------------------------- */
int Othello_draw(HWND hWnd)
{
HDC hdc;
PAINTSTRUCT ps;

int x,y;
int color;
long Pos_X;
long Pos_Y;
long End_X;
long Cir_X,Cir_Y;

	hdc = BeginPaint(hWnd , &ps);

// ---------------------------------------------
//	Window ɍ킹āAIZ̑傫ύX
// ---------------------------------------------
	LineSize	= (ps.rcPaint.right - WINDOW_SPC_WIDTH) / LINE_COUNT;	//	}Xڂ̕AEBh[̕vZB
	CircleSize	= (LineSize - (LINE_WIDTH - CIRCLE_WIDTH));				//	}Xڂ̕A~̒a߂B
	CircleOffset= (LineSize - CircleSize)/2;							//	~̍̃ItZbgvZB

// ---------------------------------------------
//	Xe[^X`悷B
// ---------------------------------------------
/* RgO
	Othello_status(hdc);
*/

// ---------------------------------------------
//	C`悷B
// ---------------------------------------------

// c̃CX{

/* RgP */
	SelectObject(hdc,hPen[0]);

	Pos_X = DRAW_INIT_X;
	Pos_Y = DRAW_INIT_Y;
	End_X = LineSize * LINE_COUNT;

	for( x=0; x <= LINE_COUNT ; x++ )
	{
		MoveToEx(hdc,Pos_X,Pos_Y,NULL);
		LineTo(hdc, Pos_X + End_X , Pos_Y);
		Pos_Y += LineSize;
	}

// ̃CX{

	Pos_X = DRAW_INIT_X;
	Pos_Y = DRAW_INIT_Y;
	End_X = LineSize * LINE_COUNT;

	for( y=0; y <= LINE_COUNT ; y++ )
	{
		MoveToEx(hdc,Pos_X,Pos_Y,NULL);
		LineTo(hdc, Pos_X  , Pos_Y + End_X);
		Pos_X += LineSize;
	}


// ---------------------------------------------
//	IZ`悷B
// ---------------------------------------------
/* RgQ */

	SelectObject(hdc,hPen[1]);

	Pos_Y = DRAW_INIT_Y + CircleOffset;		//	ixWj
	Cir_Y = Pos_Y + CircleSize;				//	EixWj

	for(y=0; y < LINE_COUNT; y++)
	{
		Pos_X = DRAW_INIT_X + CircleOffset;		//	iwWj
		Cir_X = Pos_X + CircleSize;				//	EiwWj

		for(x=0;x<LINE_COUNT;x++)
		{
//			if(color = othello_board[y][x].flag) {
				SelectObject(hdc , hBrush[((x+y)&1)+1]);
				Ellipse( hdc, Pos_X, Pos_Y, Cir_X, Cir_Y);	// Ewx	EEwx
//			}
			Pos_X += LineSize;
			Cir_X = Pos_X + CircleSize;
		}

		Pos_Y += LineSize;
		Cir_Y = Pos_Y + CircleSize;
	}

// ---------------------------------------------
//	IJ[\`悷B
// ---------------------------------------------
/* RgR
	SelectObject(hdc,hPen[2]);

	Pos_Y = DRAW_INIT_Y;			//	 + CircleOffset;		//	ixWj
	Cir_Y = Pos_Y + LineSize;		//	EixWj

	for(y=0; y < LINE_COUNT; y++)
	{
		Pos_X = DRAW_INIT_X;		// + CircleOffset;		//	iwWj
		Cir_X = Pos_X + LineSize;	//	EiwWj

		for(x=0;x<LINE_COUNT;x++)
		{
			if(othello_board[y][x].cursol)
			{	
				SelectObject( hdc, GetStockObject( NULL_BRUSH) );
				Rectangle( hdc, Pos_X, Pos_Y, Cir_X, Cir_Y );
			}
			Pos_X += LineSize;
			Cir_X = Pos_X +  LineSize;
		}

		Pos_Y += LineSize;
		Cir_Y = Pos_Y +  LineSize;
	}

*/
	EndPaint(hWnd , &ps);

return 0;
}


/* ---------------------------------------
	`yƃuV̊J
 --------------------------------------- */
int Othello_free()
{
int i;

	for(i=0;i<PEN_SIZE;i++) {
		DeleteObject(hPen[i]);
	}

	for(i=0;i<BRUSH_SIZE;i++) {
		DeleteObject(hBrush[i]);
	}

return 0;
}
