#include "Othello.h"

/* ---------------------------------------
	Q[̏
 --------------------------------------- */
int game_buff_init()
{
int x,y;

	for( x=0; x < LINE_COUNT; x++)
	{
		for( y=0; y < LINE_COUNT; y++) {
			othello_board[y][x].flag	= NULL_ID;
			othello_board[y][x].cursol	= 0;
		}
	}

	othello_board[3][3].flag = PLAYER_ID;
	othello_board[4][4].flag = PLAYER_ID;
	othello_board[3][4].flag = COM_ID;
	othello_board[4][3].flag = COM_ID;

return 0;
}

/* ---------------------------------------
	PLAYER ̌
 --------------------------------------- */
int game_play_exchange()
{
	if(	turn_flag == PLAYER_ID ) {
		turn_flag = COM_ID;
	} else if( turn_flag == COM_ID ) {
		turn_flag = PLAYER_ID;
	} else {
		turn_flag = PLAYER_ID;	// H
	}

	return 0;
}

/* ---------------------------------------
	IZ]̔HiTuj
 --------------------------------------- */
int game_tip_check(int x_st, int y_st, int x_spd, int y_spd, int my_tip, int ex_tip)
{
int x,y;
int flag = 0;
int chk_tip;

x = x_st;
y = y_st;

	for( ; ( BOARD_LEFT <= x) && ( x <= BOARD_RIGHT ) && ( BOARD_TOP <= y) && ( y <= BOARD_DOWN ); )
	{
		chk_tip = othello_board[y][x].flag;

		if( chk_tip == NULL_ID ) break;				//	ȂI
		if( chk_tip == ex_tip  ) break;				//	̃R}ȂI

		if( chk_tip == my_tip )						//	ړItopȂI
		{
			if(ex_tip) {
				othello_board[y][x].flag = ex_tip;	//	]B
			}
			flag++;
		}

		x += x_spd;
		y += y_spd;
	}

return flag;
}

/* ---------------------------------------
	IZ]̔H
 --------------------------------------- */
int game_turn_check()
{
int tip_temp[3][2] = { {NULL_ID, NULL_ID}, { COM_ID, PLAYER_ID }, { PLAYER_ID, COM_ID }};

int bias_t[8][6] = {
	{ 1, 0, 2, 0, 1, 0 },	//	E
	{-1, 0,-2, 0,-1, 0 },	//		
	{ 0, 1, 0, 2, 0, 1 },	//	
	{ 0,-1, 0,-2, 0,-1 },	//	
	{ 1, 1, 2, 2, 1, 1 },	//	E
	{-1, 1,-2, 2,-1, 1 },	//		
	{ 1,-1, 2,-2, 1,-1 },	//	E
	{-1,-1,-2,-2,-1,-1 },	//	
};

int x,y,t;
int flag;
int turn_cnt;

int player_tip,other_tip;
int my_tip;

	turn_cnt = 0;
	other_tip  = tip_temp[turn_flag][0];	//	̃R}F
	player_tip = tip_temp[turn_flag][1];	//	̃R}F

	y = board_pt.y;
	x = board_pt.x;
	my_tip = othello_board[y][x].flag;		//	̎̃R}

	for(t=0;t<8;t++) {
		if( other_tip == othello_board[ y + bias_t[t][1] ][ x + bias_t[t][0] ].flag ) {
			flag = game_tip_check( board_pt.x + bias_t[t][2], board_pt.y + bias_t[t][3], bias_t[t][4], bias_t[t][5] , player_tip , NULL_ID);	
			if(flag) {
				turn_cnt += game_tip_check( board_pt.x + bias_t[t][0], board_pt.y + bias_t[t][1], bias_t[t][4], bias_t[t][5], other_tip , player_tip);
			}
		}
	}

return turn_cnt;
}

/* ---------------------------------------
	IZ̃R}@@󂫐
 --------------------------------------- */
int game_point_calc()
{
int x,y;

//	game_point_clear();
	status_buff[NULL_ID].point	 = 0;
	status_buff[PLAYER_ID].point = 0;
	status_buff[COM_ID].point	 = 0;

	for( x=0; x < LINE_COUNT; x++)
	{
		for( y=0; y < LINE_COUNT; y++) {
			status_buff[ othello_board[y][x].flag ].point++;
		}
	}

return 0;
}

/* ---------------------------------------
	ANV
 --------------------------------------- */
int game_work_init()
{
	turn_flag = PLAYER_ID;	//	PLAYER or COM

	status_buff[NULL_ID].idno		= 0;
	status_buff[PLAYER_ID].idno		= PLAYER_ID;
	status_buff[COM_ID].idno		= COM_ID;

	status_buff[NULL_ID].pen_id		= PEN_0;
	status_buff[PLAYER_ID].pen_id	= PEN_1;
	status_buff[COM_ID].pen_id		= PEN_2;

return 0;
}


///* ---------------------------------------
//	IZ̃R}@@󂫐
// --------------------------------------- */
//int game_point_clear()
//{
//	status_buff[NULL_ID].point	 = 0;
//	status_buff[PLAYER_ID].point = 0;
//	status_buff[COM_ID].point	 = 0;
//
//return 0;
//}
